Index: src/includes/classes/Smarty/Smarty.class.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/Smarty.class.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/Smarty.class.php	(revision )
@@ -1,18 +1,18 @@
 <?php
-//die('111111');
-
 /**
  * Project:     Smarty: the PHP compiling template engine
  * File:        Smarty.class.php
- * SVN:         $Id: Smarty.class.php 4897 2014-10-14 22:29:58Z Uwe.Tews@googlemail.com $
+ *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public
  * License as published by the Free Software Foundation; either
  * version 2.1 of the License, or (at your option) any later version.
+ *
  * This library is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * Lesser General Public License for more details.
+ *
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
@@ -21,12 +21,13 @@
  * smarty-discussion-subscribe@googlegroups.com
  *
  * @link      http://www.smarty.net/
- * @copyright 2008 New Digital Group, Inc.
+ * @copyright 2015 New Digital Group, Inc.
+ * @copyright 2015 Uwe Tews
  * @author    Monte Ohrt <monte at ohrt dot com>
  * @author    Uwe Tews
  * @author    Rodney Rehm
  * @package   Smarty
- * @version   3.1.21
+ * @version   3.1.29
  */
 
 /**
@@ -55,7 +56,7 @@
     define('SMARTY_PLUGINS_DIR', SMARTY_DIR . 'plugins' . DS);
 }
 if (!defined('SMARTY_MBSTRING')) {
-    define('SMARTY_MBSTRING', function_exists('mb_split'));
+    define('SMARTY_MBSTRING', function_exists('mb_get_info'));
 }
 if (!defined('SMARTY_RESOURCE_CHAR_SET')) {
     // UTF-8 can only be done properly when mbstring is available!
@@ -72,36 +73,41 @@
 }
 
 /**
- * register the class autoloader
+ * Try loading the Smarty_Internal_Data class
+ * If we fail we must load Smarty's autoloader.
+ * Otherwise we may have a global autoloader like Composer
  */
-if (!defined('SMARTY_SPL_AUTOLOAD')) {
-    define('SMARTY_SPL_AUTOLOAD', 0);
+if (!class_exists('Smarty_Autoloader', false)) {
+    if (!class_exists('Smarty_Internal_Data', true)) {
+        require_once dirname(__FILE__) . '/Autoloader.php';
+        Smarty_Autoloader::registerBC();
-}
+    }
-
-if (SMARTY_SPL_AUTOLOAD && set_include_path(get_include_path() . PATH_SEPARATOR . SMARTY_SYSPLUGINS_DIR) !== false) {
-    $registeredAutoLoadFunctions = spl_autoload_functions();
-    if (!isset($registeredAutoLoadFunctions['spl_autoload'])) {
-        spl_autoload_register();
-    }
+}
-} else {
-    spl_autoload_register('smartyAutoload');
-}
 
 /**
  * Load always needed external class files
  */
-include_once SMARTY_SYSPLUGINS_DIR . 'smarty_internal_data.php';
-include_once SMARTY_SYSPLUGINS_DIR . 'smarty_internal_templatebase.php';
-include_once SMARTY_SYSPLUGINS_DIR . 'smarty_internal_template.php';
-include_once SMARTY_SYSPLUGINS_DIR . 'smarty_resource.php';
-include_once SMARTY_SYSPLUGINS_DIR . 'smarty_internal_resource_file.php';
-include_once SMARTY_SYSPLUGINS_DIR . 'smarty_cacheresource.php';
-include_once SMARTY_SYSPLUGINS_DIR . 'smarty_internal_cacheresource_file.php';
+if (!class_exists('Smarty_Internal_Data', false)) {
+    require_once SMARTY_SYSPLUGINS_DIR . 'smarty_internal_data.php';
+}
+require_once SMARTY_SYSPLUGINS_DIR . 'smarty_internal_extension_handler.php';
+require_once SMARTY_SYSPLUGINS_DIR . 'smarty_internal_templatebase.php';
+require_once SMARTY_SYSPLUGINS_DIR . 'smarty_internal_template.php';
+require_once SMARTY_SYSPLUGINS_DIR . 'smarty_resource.php';
+require_once SMARTY_SYSPLUGINS_DIR . 'smarty_variable.php';
+require_once SMARTY_SYSPLUGINS_DIR . 'smarty_template_source.php';
+require_once SMARTY_SYSPLUGINS_DIR . 'smarty_template_resource_base.php';
 
 /**
  * This is the main Smarty class
  *
  * @package Smarty
+ *
+ * @method int clearAllCache(int $exp_time = null, string $type = null)
+ * @method int clearCache(string $template_name, string $cache_id = null, string $compile_id = null, int $exp_time = null, string $type = null)
+ * @method int compileAllTemplates(Smarty $smarty, string $extension = '.tpl', bool $force_compile = false, int $time_limit = 0, int $max_errors = null)
+ * @method int compileAllConfig(Smarty $smarty, string $extension = '.conf', bool $force_compile = false, int $time_limit = 0, int $max_errors = null)
+ *
  */
 class Smarty3 extends Smarty_Internal_TemplateBase
 {
@@ -112,23 +118,36 @@
     /**
      * smarty version
      */
-    const SMARTY_VERSION = 'Smarty-3.1.21-dev';
+    const SMARTY_VERSION = '3.1.29';
 
     /**
      * define variable scopes
      */
     const SCOPE_LOCAL = 0;
-    const SCOPE_PARENT = 1;
-    const SCOPE_ROOT = 2;
-    const SCOPE_GLOBAL = 3;
+
+    const SCOPE_PARENT = 2;
+
+    const SCOPE_TPL_ROOT = 4;
+
+    const SCOPE_ROOT = 8;
+
+    const SCOPE_SMARTY = 16;
+
+    const SCOPE_GLOBAL = 32;
+
+    const SCOPE_BUBBLE_UP = 64;
+
     /**
      * define caching modes
      */
     const CACHING_OFF = 0;
+
     const CACHING_LIFETIME_CURRENT = 1;
+
     const CACHING_LIFETIME_SAVED = 2;
+
     /**
-     * define constant for clearing cache files be saved expiration datees
+     * define constant for clearing cache files be saved expiration dates
      */
     const CLEAR_EXPIRED = - 1;
 
@@ -136,31 +155,66 @@
      * define compile check modes
      */
     const COMPILECHECK_OFF = 0;
+
     const COMPILECHECK_ON = 1;
+
     const COMPILECHECK_CACHEMISS = 2;
+
     /**
+     * define debug modes
+     */
+    const DEBUG_OFF = 0;
+
+    const DEBUG_ON = 1;
+
+    const DEBUG_INDIVIDUAL = 2;
+
+    /**
      * modes for handling of "<?php ... ?>" tags in templates.
      */
     const PHP_PASSTHRU = 0; //-> print tags as plain text
+
     const PHP_QUOTE = 1; //-> escape tags as entities
+
     const PHP_REMOVE = 2; //-> escape tags as entities
+
     const PHP_ALLOW = 3; //-> escape tags as entities
+
     /**
      * filter types
      */
     const FILTER_POST = 'post';
+
     const FILTER_PRE = 'pre';
+
     const FILTER_OUTPUT = 'output';
+
     const FILTER_VARIABLE = 'variable';
+
     /**
      * plugin types
      */
     const PLUGIN_FUNCTION = 'function';
+
     const PLUGIN_BLOCK = 'block';
+
     const PLUGIN_COMPILER = 'compiler';
+
     const PLUGIN_MODIFIER = 'modifier';
+
     const PLUGIN_MODIFIERCOMPILER = 'modifiercompiler';
 
+    /**
+     * Resource caching modes
+     */
+    const RESOURCE_CACHE_OFF = 0;
+
+    const RESOURCE_CACHE_AUTOMATIC = 1; // cache template objects by rules
+
+    const RESOURCE_CACHE_TEMPLATE = 2; // cache all template objects
+
+    const RESOURCE_CACHE_ON = 4;    // cache source and compiled resources
+
     /**#@-*/
 
     /**
@@ -169,26 +223,31 @@
     public static $global_tpl_vars = array();
 
     /**
-     * error handler returned by set_error_hanlder() in Smarty::muteExpectedErrors()
+     * error handler returned by set_error_handler() in Smarty::muteExpectedErrors()
      */
     public static $_previous_error_handler = null;
+
     /**
      * contains directories outside of SMARTY_DIR that are to be muted by muteExpectedErrors()
      */
     public static $_muted_directories = array();
+
     /**
      * Flag denoting if Multibyte String functions are available
      */
     public static $_MBSTRING = SMARTY_MBSTRING;
+
     /**
      * The character set to adhere to (e.g. "UTF-8")
      */
     public static $_CHARSET = SMARTY_RESOURCE_CHAR_SET;
+
     /**
      * The date format to be used internally
      * (accepts date() and strftime())
      */
     public static $_DATE_FORMAT = SMARTY_RESOURCE_DATE_FORMAT;
+
     /**
      * Flag denoting if PCRE should run in UTF-8 mode
      */
@@ -204,163 +263,152 @@
      */
 
     /**
-     * auto literal on delimiters with whitspace
+     * auto literal on delimiters with whitespace
      *
      * @var boolean
      */
     public $auto_literal = true;
+
     /**
      * display error on not assigned variables
      *
      * @var boolean
      */
     public $error_unassigned = false;
+
     /**
-     * look up relative filepaths in include_path
+     * look up relative file path in include_path
      *
      * @var boolean
      */
     public $use_include_path = false;
+
     /**
      * template directory
      *
      * @var array
      */
-    private $template_dir = array();
+    private $template_dir = array('./templates/');
+
     /**
      * joined template directory string used in cache keys
      *
      * @var string
      */
-    public $joined_template_dir = null;
+    public $_joined_template_dir = null;
+
     /**
      * joined config directory string used in cache keys
      *
      * @var string
      */
-    public $joined_config_dir = null;
+    public $_joined_config_dir = null;
+
     /**
      * default template handler
      *
      * @var callable
      */
     public $default_template_handler_func = null;
+
     /**
      * default config handler
      *
      * @var callable
      */
     public $default_config_handler_func = null;
+
     /**
      * default plugin handler
      *
      * @var callable
      */
     public $default_plugin_handler_func = null;
+
     /**
      * compile directory
      *
      * @var string
      */
-    private $compile_dir = null;
+    private $compile_dir = './templates_c/';
+
     /**
      * plugins directory
      *
      * @var array
      */
-    private $plugins_dir = array();
+    private $plugins_dir = null;
+
     /**
      * cache directory
      *
      * @var string
      */
-    private $cache_dir = null;
+    private $cache_dir = './cache/';
+
     /**
      * config directory
      *
      * @var array
      */
-    private $config_dir = array();
+    private $config_dir = array('./configs/');
+
     /**
      * force template compiling?
      *
      * @var boolean
      */
     public $force_compile = false;
+
     /**
      * check template for modifications?
      *
      * @var boolean
      */
     public $compile_check = true;
+
     /**
      * use sub dirs for compiled/cached files?
      *
      * @var boolean
      */
     public $use_sub_dirs = false;
+
     /**
      * allow ambiguous resources (that are made unique by the resource handler)
      *
      * @var boolean
      */
     public $allow_ambiguous_resources = false;
+
     /**
-     * caching enabled
-     *
-     * @var boolean
-     */
-    public $caching = false;
-    /**
      * merge compiled includes
      *
      * @var boolean
      */
     public $merge_compiled_includes = false;
+
     /**
-     * template inheritance merge compiled includes
-     *
-     * @var boolean
-     */
-    public $inheritance_merge_compiled_includes = true;
-    /**
-     * cache lifetime in seconds
-     *
-     * @var integer
-     */
-    public $cache_lifetime = 3600;
-    /**
      * force cache file creation
      *
      * @var boolean
      */
     public $force_cache = false;
+
     /**
-     * Set this if you want different sets of cache files for the same
-     * templates.
-     *
-     * @var string
-     */
-    public $cache_id = null;
-    /**
-     * Set this if you want different sets of compiled files for the same
-     * templates.
-     *
-     * @var string
-     */
-    public $compile_id = null;
-    /**
      * template left-delimiter
      *
      * @var string
      */
     public $left_delimiter = "{";
+
     /**
      * template right-delimiter
      *
      * @var string
      */
     public $right_delimiter = "}";
+
     /**#@+
      * security
      */
@@ -372,33 +420,28 @@
      * @see Smarty_Security
      */
     public $security_class = 'Smarty_Security';
+
     /**
      * implementation of security class
      *
      * @var Smarty_Security
      */
     public $security_policy = null;
+
     /**
      * controls handling of PHP-blocks
      *
      * @var integer
      */
     public $php_handling = self::PHP_PASSTHRU;
+
     /**
      * controls if the php template file resource is allowed
      *
      * @var bool
      */
     public $allow_php_templates = false;
-    /**
-     * Should compiled-templates be prevented from being called directly?
-     * {@internal
-     * Currently used by Smarty_Internal_Template only.
-     * }}
-     *
-     * @var boolean
-     */
-    public $direct_access_security = true;
+
     /**#@-*/
     /**
      * debug mode
@@ -407,6 +450,7 @@
      * @var boolean
      */
     public $debugging = false;
+
     /**
      * This determines if debugging is enable-able from the browser.
      * <ul>
@@ -417,32 +461,29 @@
      * @var string
      */
     public $debugging_ctrl = 'NONE';
+
     /**
      * Name of debugging URL-param.
      * Only used when $debugging_ctrl is set to 'URL'.
      * The name of the URL-parameter that activates debugging.
      *
-     * @var type
+     * @var string
      */
     public $smarty_debug_id = 'SMARTY_DEBUG';
+
     /**
      * Path of debug template.
      *
      * @var string
      */
     public $debug_tpl = null;
+
     /**
      * When set, smarty uses this value as error_reporting-level.
      *
      * @var int
      */
     public $error_reporting = null;
-    /**
-     * Internal flag for getTags()
-     *
-     * @var boolean
-     */
-    public $get_used_tags = false;
 
     /**#@+
      * config var settings
@@ -454,12 +495,14 @@
      * @var boolean
      */
     public $config_overwrite = true;
+
     /**
      * Controls whether config values of on/true/yes and off/false/no get converted to boolean.
      *
      * @var boolean
      */
     public $config_booleanize = true;
+
     /**
      * Controls whether hidden config sections/vars are read from the file.
      *
@@ -479,12 +522,14 @@
      * @var boolean
      */
     public $compile_locking = true;
+
     /**
-     * Controls whether cache resources should emply locking mechanism
+     * Controls whether cache resources should use locking mechanism
      *
      * @var boolean
      */
     public $cache_locking = false;
+
     /**
      * seconds to wait for acquiring a lock before ignoring the write lock
      *
@@ -495,18 +540,13 @@
     /**#@-*/
 
     /**
-     * global template functions
-     *
-     * @var array
-     */
-    public $template_functions = array();
-    /**
      * resource type used if none given
      * Must be an valid key of $registered_resources.
      *
      * @var string
      */
     public $default_resource_type = 'file';
+
     /**
      * caching type
      * Must be an element of $cache_resource_types.
@@ -514,259 +554,171 @@
      * @var string
      */
     public $caching_type = 'file';
+
     /**
-     * internal config properties
-     *
-     * @var array
-     */
-    public $properties = array();
-    /**
      * config type
      *
      * @var string
      */
     public $default_config_type = 'file';
+
     /**
-     * cached template objects
+     * enable resource caching
      *
-     * @var array
+     * @var bool
      */
-    public $template_objects = array();
+    public $resource_cache_mode = 1;
+
     /**
      * check If-Modified-Since headers
      *
      * @var boolean
      */
     public $cache_modified_check = false;
+
     /**
      * registered plugins
      *
      * @var array
      */
     public $registered_plugins = array();
+
     /**
-     * plugin search order
-     *
-     * @var array
-     */
-    public $plugin_search_order = array('function', 'block', 'compiler', 'class');
-    /**
      * registered objects
      *
      * @var array
      */
     public $registered_objects = array();
+
     /**
      * registered classes
      *
      * @var array
      */
     public $registered_classes = array();
+
     /**
      * registered filters
      *
      * @var array
      */
     public $registered_filters = array();
+
     /**
      * registered resources
      *
      * @var array
      */
     public $registered_resources = array();
+
     /**
-     * resource handler cache
-     *
-     * @var array
-     */
-    public $_resource_handlers = array();
-    /**
      * registered cache resources
      *
      * @var array
      */
     public $registered_cache_resources = array();
+
     /**
-     * cache resource handler cache
-     *
-     * @var array
-     */
-    public $_cacheresource_handlers = array();
-    /**
      * autoload filter
      *
      * @var array
      */
     public $autoload_filters = array();
+
     /**
      * default modifier
      *
      * @var array
      */
     public $default_modifiers = array();
+
     /**
      * autoescape variable output
      *
      * @var boolean
      */
     public $escape_html = false;
+
     /**
-     * global internal smarty vars
-     *
-     * @var array
-     */
-    public static $_smarty_vars = array();
-    /**
      * start time for execution time calculation
      *
      * @var int
      */
     public $start_time = 0;
+
     /**
-     * default file permissions
-     *
-     * @var int
-     */
-    public $_file_perms = 0644;
-    /**
-     * default dir permissions
-     *
-     * @var int
-     */
-    public $_dir_perms = 0771;
-    /**
-     * block tag hierarchy
-     *
-     * @var array
-     */
-    public $_tag_stack = array();
-    /**
-     * self pointer to Smarty object
-     *
-     * @var Smarty
-     */
-    public $smarty;
-    /**
      * required by the compiler for BC
      *
      * @var string
      */
     public $_current_file = null;
+
     /**
      * internal flag to enable parser debugging
      *
      * @var bool
      */
     public $_parserdebug = false;
+
     /**
-     * Saved parameter of merged templates during compilation
+     * This object type (Smarty = 1, template = 2, data = 4)
      *
-     * @var array
+     * @var int
      */
-    public $merged_templates_func = array();
+    public $_objType = 1;
 
     /**
-     * Cache of is_file results of loadPlugin()
+     * Debug object
-     * 
+     *
+     * @var Smarty_Internal_Debug
+     */
+    public $_debug = null;
+
+    /**
+     * removed properties
+     *
+     * @var string[]
+     */
+    private static $obsoleteProperties = array('resource_caching', 'template_resource_caching',
+                                               'direct_access_security', '_dir_perms', '_file_perms',
+                                               'plugin_search_order', 'inheritance_merge_compiled_includes');
+
+    /**
+     * List of private properties which will call getter/setter ona direct access
+     *
      * @var array
      */
-    public static $_is_file_cache= array();
+    private static $accessMap = array('template_dir' => 'TemplateDir', 'config_dir' => 'ConfigDir',
+                                      'plugins_dir'  => 'PluginsDir', 'compile_dir' => 'CompileDir',
+                                      'cache_dir'    => 'CacheDir',);
 
     /**#@-*/
 
     /**
      * Initialize new Smarty object
-
      */
     public function __construct()
     {
-        // selfpointer needed by some other class methods
-        $this->smarty = $this;
+        parent::__construct();
         if (is_callable('mb_internal_encoding')) {
             mb_internal_encoding(Smarty::$_CHARSET);
         }
         $this->start_time = microtime(true);
-        // set default dirs
-        $this->setTemplateDir('.' . DS . 'templates' . DS)
-            ->setCompileDir('.' . DS . 'templates_c' . DS)
-            ->setPluginsDir(SMARTY_PLUGINS_DIR)
-            ->setCacheDir('.' . DS . 'cache' . DS)
-            ->setConfigDir('.' . DS . 'lang' . DS);
 
-        $this->debug_tpl = 'file:' . dirname(__FILE__) . '/debug.tpl';
         if (isset($_SERVER['SCRIPT_NAME'])) {
-            $this->assignGlobal('SCRIPT_NAME', $_SERVER['SCRIPT_NAME']);
+            Smarty::$global_tpl_vars['SCRIPT_NAME'] = new Smarty_Variable($_SERVER['SCRIPT_NAME']);
         }
-    }
 
-    /**
-     * Class destructor
-     */
-    public function __destruct()
-    {
-        // intentionally left blank
-    }
+        // Check if we're running on windows
+        Smarty::$_IS_WINDOWS = strtoupper(substr(PHP_OS, 0, 3)) === 'WIN';
 
-    /**
-     * <<magic>> set selfpointer on cloned object
-     */
-    public function __clone()
-    {
-        $this->smarty = $this;
+        // let PCRE (preg_*) treat strings as ISO-8859-1 if we're not dealing with UTF-8
+        if (Smarty::$_CHARSET !== 'UTF-8') {
+            Smarty::$_UTF8_MODIFIER = '';
-    }
+        }
-
-    /**
-     * <<magic>> Generic getter.
-     * Calls the appropriate getter function.
-     * Issues an E_USER_NOTICE if no valid getter is found.
-     *
-     * @param  string $name property name
-     *
-     * @return mixed
-     */
-    public function __get($name)
-    {
-        $allowed = array(
-            'template_dir' => 'getTemplateDir',
-            'config_dir'   => 'getConfigDir',
-            'plugins_dir'  => 'getPluginsDir',
-            'compile_dir'  => 'getCompileDir',
-            'cache_dir'    => 'getCacheDir',
-        );
-
-        if (isset($allowed[$name])) {
-            return $this->{$allowed[$name]}();
-        } else {
-            trigger_error('Undefined property: ' . get_class($this) . '::$' . $name, E_USER_NOTICE);
-        }
+    }
-    }
 
     /**
-     * <<magic>> Generic setter.
-     * Calls the appropriate setter function.
-     * Issues an E_USER_NOTICE if no valid setter is found.
-     *
-     * @param string $name  property name
-     * @param mixed  $value parameter passed to setter
-     */
-    public function __set($name, $value)
-    {
-        $allowed = array(
-            'template_dir' => 'setTemplateDir',
-            'config_dir'   => 'setConfigDir',
-            'plugins_dir'  => 'setPluginsDir',
-            'compile_dir'  => 'setCompileDir',
-            'cache_dir'    => 'setCacheDir',
-        );
-
-        if (isset($allowed[$name])) {
-            $this->{$allowed[$name]}($value);
-        } else {
-            trigger_error('Undefined property: ' . get_class($this) . '::$' . $name, E_USER_NOTICE);
-        }
-    }
-
-    /**
      * Check if a template resource exists
      *
      * @param  string $resource_name template name
@@ -775,14 +727,9 @@
      */
     public function templateExists($resource_name)
     {
-        // create template object
-        $save = $this->template_objects;
-        $tpl = new $this->template_class($resource_name, $this);
-        // check if it does exists
-        $result = $tpl->source->exists;
-        $this->template_objects = $save;
-
-        return $result;
+        // create source object
+        $source = Smarty_Template_Source::load(null, $this, $resource_name);
+        return $source->exists;
     }
 
     /**
@@ -811,43 +758,6 @@
     }
 
     /**
-     * Empty cache folder
-     *
-     * @param  integer $exp_time expiration time
-     * @param  string  $type     resource type
-     *
-     * @return integer number of cache files deleted
-     */
-    public function clearAllCache($exp_time = null, $type = null)
-    {
-        // load cache resource and call clearAll
-        $_cache_resource = Smarty_CacheResource::load($this, $type);
-        Smarty_CacheResource::invalidLoadedCache($this);
-
-        return $_cache_resource->clearAll($this, $exp_time);
-    }
-
-    /**
-     * Empty cache for a specific template
-     *
-     * @param  string  $template_name template name
-     * @param  string  $cache_id      cache id
-     * @param  string  $compile_id    compile id
-     * @param  integer $exp_time      expiration time
-     * @param  string  $type          resource type
-     *
-     * @return integer number of cache files deleted
-     */
-    public function clearCache($template_name, $cache_id = null, $compile_id = null, $exp_time = null, $type = null)
-    {
-        // load cache resource and call clear
-        $_cache_resource = Smarty_CacheResource::load($this, $type);
-        Smarty_CacheResource::invalidLoadedCache($this);
-
-        return $_cache_resource->clear($this, $template_name, $cache_id, $compile_id, $exp_time);
-    }
-
-    /**
      * Loads security class and enables security
      *
      * @param  string|Smarty_Security $security_class if a string is used, it must be class-name
@@ -857,27 +767,10 @@
      */
     public function enableSecurity($security_class = null)
     {
-        if ($security_class instanceof Smarty_Security) {
-            $this->security_policy = $security_class;
-
+        Smarty_Security::enableSecurity($this, $security_class);
-            return $this;
+        return $this;
-        } elseif (is_object($security_class)) {
-            throw new SmartyException("Class '" . get_class($security_class) . "' must extend Smarty_Security.");
-        }
+    }
-        if ($security_class == null) {
-            $security_class = $this->security_class;
-        }
-        if (!class_exists($security_class)) {
-            throw new SmartyException("Security class '$security_class' is not defined");
-        } elseif ($security_class !== 'Smarty_Security' && !is_subclass_of($security_class, 'Smarty_Security')) {
-            throw new SmartyException("Class '$security_class' must extend Smarty_Security.");
-        } else {
-            $this->security_policy = new $security_class($this);
-        }
 
-        return $this;
-    }
-
     /**
      * Disable security
      *
@@ -894,18 +787,18 @@
      * Set template directory
      *
      * @param  string|array $template_dir directory(s) of template sources
+     * @param bool          $isConfig     true for config_dir
      *
-     * @return Smarty       current Smarty instance for chaining
+     * @return \Smarty current Smarty instance for chaining
      */
-    public function setTemplateDir($template_dir)
+    public function setTemplateDir($template_dir, $isConfig = false)
     {
-        $this->template_dir = array();
-        foreach ((array) $template_dir as $k => $v) {
-            $this->template_dir[$k] = preg_replace('#(\w+)(/|\\\\){1,}#', '$1$2', rtrim($v, '/\\')) . DS;
-        }
-
-        $this->joined_template_dir = join(DIRECTORY_SEPARATOR, $this->template_dir);
-
+        $type = $isConfig ? 'config_dir' : 'template_dir';
+        $joined = '_joined_' . $type;
+        $this->{$type} = (array) $template_dir;
+        $this->{$joined} = join(' # ', $this->{$type});
+        $this->_cache[$type . '_new'] = true;
+        $this->_cache[$type] = false;
         return $this;
     }
 
@@ -914,55 +807,53 @@
      *
      * @param  string|array $template_dir directory(s) of template sources
      * @param  string       $key          of the array element to assign the template dir to
+     * @param bool          $isConfig     true for config_dir
      *
      * @return Smarty          current Smarty instance for chaining
-     * @throws SmartyException when the given template directory is not valid
      */
-    public function addTemplateDir($template_dir, $key = null)
+    public function addTemplateDir($template_dir, $key = null, $isConfig = false)
     {
-        // make sure we're dealing with an array
-        $this->template_dir = (array) $this->template_dir;
-
-        if (is_array($template_dir)) {
-            foreach ($template_dir as $k => $v) {
-                $v = preg_replace('#(\w+)(/|\\\\){1,}#', '$1$2', rtrim($v, '/\\')) . DS;
-                if (is_int($k)) {
-                    // indexes are not merged but appended
-                    $this->template_dir[] = $v;
-                } else {
-                    // string indexes are overridden
-                    $this->template_dir[$k] = $v;
+        $type = $isConfig ? 'config_dir' : 'template_dir';
+        $joined = '_joined_' . $type;
+        if (!isset($this->_cache[$type])) {
+            $this->{$type} = (array) $this->{$type};
+            $this->{$joined} = join(' # ', $this->{$type});
+            $this->_cache[$type . '_new'] = true;
+            $this->_cache[$type] = false;
-                }
+        }
-            }
-        } else {
-            $v = preg_replace('#(\w+)(/|\\\\){1,}#', '$1$2', rtrim($template_dir, '/\\')) . DS;
-            if ($key !== null) {
-                // override directory at specified index
-                $this->template_dir[$key] = $v;
-            } else {
-                // append new directory
-                $this->template_dir[] = $v;
-            }
-        }
-        $this->joined_template_dir = join(DIRECTORY_SEPARATOR, $this->template_dir);
-
+        $this->{$joined} .= ' # ' . join(' # ', (array) $template_dir);
+        $this->_addDir($type, $template_dir, $key);
         return $this;
     }
 
     /**
      * Get template directories
      *
-     * @param mixed $index index of directory to get, null to get all
+     * @param mixed $index    index of directory to get, null to get all
+     * @param bool  $isConfig true for config_dir
      *
-     * @return array|string list of template directories, or directory of $index
+     * @return array list of template directories, or directory of $index
      */
-    public function getTemplateDir($index = null)
+    public function getTemplateDir($index = null, $isConfig = false)
     {
+        $type = $isConfig ? 'config_dir' : 'template_dir';
+        if (!isset($this->_cache[$type])) {
+            $joined = '_joined_' . $type;
+            $this->{$type} = (array) $this->{$type};
+            $this->{$joined} = join(' # ', $this->{$type});
+            $this->_cache[$type] = false;
+        }
+        if ($this->_cache[$type] == false) {
+            foreach ($this->{$type} as $k => $v) {
+                $this->{$type}[$k] = $this->_realpath($v . DS, true);
+            }
+            $this->_cache[$type . '_new'] = true;
+            $this->_cache[$type] = true;
+        }
         if ($index !== null) {
-            return isset($this->template_dir[$index]) ? $this->template_dir[$index] : null;
+            return isset($this->{$type}[$index]) ? $this->{$type}[$index] : null;
         }
-
-        return (array) $this->template_dir;
+        return $this->{$type};
     }
 
     /**
